<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: drone.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('drone_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">drone.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="drone_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="drone_8hh.html">drone.hh</a>&quot;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno"><a class="line" href="class_drone.html#ac92e53bc078523b250bba5a33c010b33">    6</a></span>&#160;vector&lt;Vector3D&gt; <a class="code" href="class_drone.html#ac92e53bc078523b250bba5a33c010b33">Drone::moveForward</a>(<span class="keyword">const</span> <span class="keywordtype">double</span> &amp;angleChange, <span class="keyword">const</span> <span class="keywordtype">double</span> &amp;distance, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;frames) {</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    <span class="comment">//Calculate translation in each frames of animation</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> translation = (calculateTranslation(angleChange, distance) / frames);</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <a class="code" href="class_shape.html#a499ab02e6fd00d35c87e9409cab672dc">Cuboid::translate</a>(translation); <span class="comment">// Translate drone body</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    <a class="code" href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">Cuboid::translateCover</a>(translation); <span class="comment">// Translate drone cover</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    rotateRotor(frames); <span class="comment">// Rotate rotors</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    <span class="comment">// Save all coordinates to results files</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    draw(kDroneFile, kLeftFrontRotorFile_, kRightFrontRotorFile_, kLeftRearRotorFile_, kRightRearRotorFile_);</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keywordflow">return</span> <a class="code" href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">Cuboid::getNextStepCover</a>(translation); <span class="comment">// Drone cover in next step</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;}</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="class_drone.html#abe42c3f974859bc10b58e63adb1498c0">   20</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_drone.html#abe42c3f974859bc10b58e63adb1498c0">Drone::rotate</a>(<span class="keyword">const</span> <span class="keywordtype">double</span> &amp;rotateAngle, <span class="keyword">const</span> <span class="keywordtype">int</span> &amp;frames) {</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <a class="code" href="class_shape.html#a4ab9606f25f5121c5d09e95de802f4c0">Cuboid::writeAngle</a>(rotateAngle / frames); <span class="comment">// Rotate the drone</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    rotateRotor(frames); <span class="comment">// Rotate the rotors</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="comment">// Save all coordinates to results files</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    draw(kDroneFile, kLeftFrontRotorFile_, kRightFrontRotorFile_, kLeftRearRotorFile_, kRightRearRotorFile_);</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;}</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="class_drone.html#af8bc6a465e5d55fdbd0985a03431a40c">   29</a></span>&#160;<a class="code" href="class_vector.html">Vector3D</a> <a class="code" href="class_drone.html#af8bc6a465e5d55fdbd0985a03431a40c">Drone::calculateTranslation</a>(<span class="keywordtype">double</span> angleChange, <span class="keywordtype">double</span> distance)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> result;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    result[0] = (cos(makeRadians(angleChange)) * distance) * cos(makeRadians(angle_)); <span class="comment">// OX axis</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    result[1] = (cos(makeRadians(angleChange)) * distance) * sin(makeRadians(angle_)); <span class="comment">// OY axis</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    result[2] = (sin(makeRadians(angleChange)) * distance); <span class="comment">// OZ axis</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160; </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="keywordflow">return</span> result;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;}</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="class_drone.html#aaaf054aec74ad44a41dc5957f1e36b87">   38</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="class_drone.html#aaaf054aec74ad44a41dc5957f1e36b87">Drone::checkCollision</a>(<span class="keyword">const</span> std::vector&lt;Vector3D&gt; &amp;droneCover)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;}</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="line" href="class_drone.html#ab692baa4be5c43b72990ce1b01bdc805">   42</a></span>&#160;<a class="code" href="class_drone.html#ab692baa4be5c43b72990ce1b01bdc805">Drone::Drone</a>() {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment">// Open file with model coordinates of drone</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    ifstream inputFile;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    inputFile.open(kRotorModel_);</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment">// Check if the file is open correctly</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordflow">if</span> (!inputFile.is_open()) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to load model rotor file!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    }</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    <span class="comment">// Read all of model coordinates</span></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <a class="code" href="class_vector.html">Vector3D</a> point;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="keywordflow">while</span> (inputFile &gt;&gt; point) {</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        leftFrontRotor_.push_back(point);</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        rightFrontRotor_.push_back(point);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        leftRearRotor_.push_back(point);</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        rightRearRotor_.push_back(point);</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        currentCounter_ += 4; <span class="comment">// Increase counter of total number of Vector3D objects</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        allCounter_ += 4; <span class="comment">// Increase counter of current number of Vector3D objects</span></div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    }</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    inputFile.close();</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;}</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="class_drone.html#a43e891fd105579c5562ada343df72bb2">   67</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_drone.html#a43e891fd105579c5562ada343df72bb2">Drone::draw</a>(<span class="keyword">const</span> std::string &amp;cuboidFilename,</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;                 <span class="keyword">const</span> std::string &amp;leftFrontRotorFilename,</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;                 <span class="keyword">const</span> std::string &amp;rightFrontRotorFilename,</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;                 <span class="keyword">const</span> std::string &amp;leftRearRotorFilename,</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;                 <span class="keyword">const</span> std::string &amp;rightRearRotorFilename)<span class="keyword"> const </span>{</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <span class="comment">// Save drone body ro result file</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <a class="code" href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">Cuboid::draw</a>(cuboidFilename);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="comment">// Rotation matrix in OZ axis</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <a class="code" href="class_rotation_matrix.html">RotationMatrix</a> matrix(angle_);</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="comment">// Open files to which all rotors coordinates will be saved</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    ofstream outputFile, outputFile2, outputFile3, outputFile4;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    outputFile.open(leftFrontRotorFilename);</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    outputFile2.open(rightFrontRotorFilename);</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    outputFile3.open(leftRearRotorFilename);</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    outputFile4.open(rightRearRotorFilename);</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160; </div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <span class="comment">// Check if the files are open correctly</span></div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <span class="keywordflow">if</span> (!outputFile.is_open() || !outputFile2.is_open() || !outputFile3.is_open() || !outputFile4.is_open()) {</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        cerr &lt;&lt; <span class="stringliteral">&quot;Unable to open rotors files!&quot;</span> &lt;&lt; endl;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;        <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    }</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160; </div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="comment">// Save all coordinates to the result file</span></div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; (i &lt; leftFrontRotor_.size() || i &lt; rightFrontRotor_.size() || i &lt; leftRearRotor_.size()</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        || i &lt; rightRearRotor_.size()); ++i) {</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        outputFile &lt;&lt; (matrix * (leftFrontRotor_[i] + leftFrontRotorTranslation_)) + translation_ &lt;&lt; endl;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        outputFile2 &lt;&lt; (matrix * (rightFrontRotor_[i] + rightFrontRotorTranslation_)) + translation_ &lt;&lt; endl;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        outputFile3 &lt;&lt; (matrix * (leftRearRotor_[i] + leftRearRotorTranslation_)) + translation_ &lt;&lt; endl;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        outputFile4 &lt;&lt; (matrix * (rightRearRotor_[i] + rightRearRotorTranslation_)) + translation_ &lt;&lt; endl;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        <span class="keywordflow">if</span> (i % 4 == 3) {</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            outputFile &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            outputFile2 &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            outputFile3 &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;            outputFile4 &lt;&lt; <span class="stringliteral">&quot;#\n\n&quot;</span>;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        }</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    }</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160; </div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    outputFile.close();</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    outputFile2.close();</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    outputFile3.close();</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    outputFile4.close();</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;}</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160; </div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="class_drone.html#a7a43dc06d8b00fd2e9615ad26c72887c">  112</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_drone.html#a7a43dc06d8b00fd2e9615ad26c72887c">Drone::rotateRotor</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> &amp;frames) {</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="comment">// Rotation matrix in OX axis</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <a class="code" href="class_rotation_matrix.html">RotationMatrix</a> rotate(360.0, frames);</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160; </div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span> &amp;i : leftFrontRotor_) i = rotate * i;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160; </div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span> &amp;i : rightFrontRotor_) i = rotate * i;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span> &amp;i : leftRearRotor_) i = rotate * i;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160; </div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">auto</span> &amp;i : rightRearRotor_) i = rotate * i;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="adrone_8hh_html"><div class="ttname"><a href="drone_8hh.html">drone.hh</a></div></div>
<div class="ttc" id="aclass_shape_html_a4ab9606f25f5121c5d09e95de802f4c0"><div class="ttname"><a href="class_shape.html#a4ab9606f25f5121c5d09e95de802f4c0">Shape::writeAngle</a></div><div class="ttdeci">void writeAngle(double change)</div><div class="ttdoc">Increase rotation angle.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00062">shape.hh:62</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a8e5ab60bcdf1e2a0571f1d38800543a4"><div class="ttname"><a href="class_cuboid.html#a8e5ab60bcdf1e2a0571f1d38800543a4">Cuboid::translateCover</a></div><div class="ttdeci">void translateCover(const Vector3D &amp;change)</div><div class="ttdoc">Translates the drone cover. Moves the drone cover the same translation vector as the drone body.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00052">cuboid.cpp:52</a></div></div>
<div class="ttc" id="aclass_drone_html_af8bc6a465e5d55fdbd0985a03431a40c"><div class="ttname"><a href="class_drone.html#af8bc6a465e5d55fdbd0985a03431a40c">Drone::calculateTranslation</a></div><div class="ttdeci">Vector3D calculateTranslation(double angleChange, double distance) const</div><div class="ttdoc">Calculate translation vector.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00029">drone.cpp:29</a></div></div>
<div class="ttc" id="aclass_shape_html_a499ab02e6fd00d35c87e9409cab672dc"><div class="ttname"><a href="class_shape.html#a499ab02e6fd00d35c87e9409cab672dc">Shape::translate</a></div><div class="ttdeci">void translate(const Vector3D &amp;change)</div><div class="ttdoc">Increase translation vector.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00056">shape.hh:56</a></div></div>
<div class="ttc" id="aclass_cuboid_html_ac05b065f9298c6577f8bf4af96ae08a2"><div class="ttname"><a href="class_cuboid.html#ac05b065f9298c6577f8bf4af96ae08a2">Cuboid::draw</a></div><div class="ttdeci">void draw(const std::string &amp;filename) const override</div><div class="ttdoc">Saves the bottom coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00029">cuboid.cpp:29</a></div></div>
<div class="ttc" id="aclass_drone_html_abe42c3f974859bc10b58e63adb1498c0"><div class="ttname"><a href="class_drone.html#abe42c3f974859bc10b58e63adb1498c0">Drone::rotate</a></div><div class="ttdeci">void rotate(const double &amp;rotateAngle, const int &amp;frames)</div><div class="ttdoc">Rotate the drone in OZ axis.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00020">drone.cpp:20</a></div></div>
<div class="ttc" id="aclass_drone_html_ac92e53bc078523b250bba5a33c010b33"><div class="ttname"><a href="class_drone.html#ac92e53bc078523b250bba5a33c010b33">Drone::moveForward</a></div><div class="ttdeci">std::vector&lt; Vector3D &gt; moveForward(const double &amp;angleChange, const double &amp;distance, const int &amp;frames)</div><div class="ttdoc">Move drone forward.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00006">drone.cpp:6</a></div></div>
<div class="ttc" id="aclass_rotation_matrix_html"><div class="ttname"><a href="class_rotation_matrix.html">RotationMatrix</a></div><div class="ttdoc">Models the concept of the rotation matrix of geometric object.</div><div class="ttdef"><b>Definition:</b> <a href="rotation_matrix_8hh_source.html#l00009">rotationMatrix.hh:9</a></div></div>
<div class="ttc" id="aclass_cuboid_html_a01ff3d2d1f5d2736d614bfe2adf695dd"><div class="ttname"><a href="class_cuboid.html#a01ff3d2d1f5d2736d614bfe2adf695dd">Cuboid::getNextStepCover</a></div><div class="ttdeci">std::vector&lt; Vector3D &gt; getNextStepCover(const Vector3D &amp;translation) const</div><div class="ttdoc">Calculate the coordinates of drone cover in next step of animation (movement)</div><div class="ttdef"><b>Definition:</b> <a href="cuboid_8cpp_source.html#l00060">cuboid.cpp:60</a></div></div>
<div class="ttc" id="aclass_drone_html_a43e891fd105579c5562ada343df72bb2"><div class="ttname"><a href="class_drone.html#a43e891fd105579c5562ada343df72bb2">Drone::draw</a></div><div class="ttdeci">void draw(const std::string &amp;cuboidFilename, const std::string &amp;leftFrontRotorFilename, const std::string &amp;rightFrontRotorFilename, const std::string &amp;leftRearRotorFilename, const std::string &amp;rightRearRotorFilename) const</div><div class="ttdoc">Saves the bottom coordinates to a result file.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00067">drone.cpp:67</a></div></div>
<div class="ttc" id="aclass_vector_html"><div class="ttname"><a href="class_vector.html">Vector&lt; double, 3 &gt;</a></div></div>
<div class="ttc" id="aclass_drone_html_a7a43dc06d8b00fd2e9615ad26c72887c"><div class="ttname"><a href="class_drone.html#a7a43dc06d8b00fd2e9615ad26c72887c">Drone::rotateRotor</a></div><div class="ttdeci">void rotateRotor(const int &amp;frames)</div><div class="ttdoc">Rotates the rotors.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00112">drone.cpp:112</a></div></div>
<div class="ttc" id="aclass_drone_html_ab692baa4be5c43b72990ce1b01bdc805"><div class="ttname"><a href="class_drone.html#ab692baa4be5c43b72990ce1b01bdc805">Drone::Drone</a></div><div class="ttdeci">Drone()</div><div class="ttdoc">Constructor for Drone class.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00042">drone.cpp:42</a></div></div>
<div class="ttc" id="aclass_drone_html_aaaf054aec74ad44a41dc5957f1e36b87"><div class="ttname"><a href="class_drone.html#aaaf054aec74ad44a41dc5957f1e36b87">Drone::checkCollision</a></div><div class="ttdeci">bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover) const override</div><div class="ttdoc">Checks if in the next step of movement will be collision with another drone.</div><div class="ttdef"><b>Definition:</b> <a href="drone_8cpp_source.html#l00038">drone.cpp:38</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="drone_8cpp.html">drone.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
